# tkinter,messageboxをインポート
**tkinterをtk、messageboxをtmsgとし、インポートする**
`5,6行目`を自分で作成。
```python
import tkinter as tk
from tkinter import messagebox as tmsg
```

# ウィンドウの作成
**ウィンドウを作成する**  
``13,14行目``を自分で作成。
```python
root = tk.Tk()
root.title("〇✕ゲーム")
root.bind("<1>", mark)
root.mainloop()
```

## プレイヤー
```python
PLAYER = 1
```

## 初期配置
```python
init = 0
```
## 盤面
```python
banmen = [[init for x in range(3)] for y in range(3)]
```
## ボタン
```python
BUTTON = [[tk.Button(root, width = 20 , height = 7) for x in range(3)] for y in range(3)]
```

## プレイヤー変更
```python
    PLAYER = change()
```

# 初期化
**盤面を初期化する**
```python
def init_banmen():
    global init, banmen
    banmen =  [[init for x in range(3)] for y in range(3)]
```

# 縦の判定
**縦の判定を設置**  
`54行目`を改変。縦の判定を定義。
```python
def tatehantei():
    global banmen
    for x in range(3):
        if banmen[x][0] != 0:
            if banmen[x][0] == banmen[x][1] == banmen[x][2]:
                return banmen[x][0]
```
        
# 横の判定
**横の判定を設置**  
`66行目`を改変。横の判定を定義。
```python
def yokohantei():
    global banmen
    for y in range(3):
        if banmen[0][y] != 0:
            if banmen[0][y] == banmen[1][y] == banmen[2][y]:
                return banmen[0][y]
``` 
            
# 斜めの判定
**斜めの判定を設置**  
`78行目`を改変。斜めの判定を定義。
```python
def nanamehantei():
    global banmen
    if banmen[1][1] != 0:
        if banmen[0][0] == banmen[1][1] == banmen[2][2]:
            return banmen[1][1]
        elif banmen[2][0] == banmen[1][1] == banmen[0][2]:
            return banmen[1][1]
```

# 判定なし
**判定がないときを設置**  
`91行目`を改変。判定なしを定義。
```python
def hanteinasi():
    for x in range(3):
        for y in range(3):
            if banmen[x][y] == 0:
                return 0
```   
    

# プレイヤーチェンジ
**-1をかけてプレイヤー交代をさせる**
```python
def change():
    global PLAYER
    return PLAYER * (-1)
```

# ボタンにテキストを追加
**３ｘ３のボタンに〇✕とテキストを設置**  
`119,121,125,127行目`を改変。〇✕に色を設置し、テキストを表示するようにした。
```python
def mark(e):
    global PLAYER, banmen
    for x in range(3):
        for y in range(3):
            if e.widget == BUTTON[y][x]:     
                if PLAYER == 1: 
                    #テキストと色➀
                    e.widget["text"] = "〇"
                    e.widget["foreground"] = "red"
                    banmen[y][x] = 1    
                    tmsg.showinfo("〇✕ゲーム", "後攻プレイヤーの番です")         
                elif PLAYER == -1:
                    #テキストと色➁
                     e.widget["text"] = "✕"
                     e.widget["foreground"] = "blue"
                     banmen[y][x] = -1                 
                     tmsg.showinfo("〇✕ゲーム", "先行プレイヤーの番です")
```



# 判定結果
**誰が勝ったかを判定し、ウィンドウを閉じる。**  
`137,138,140,141,144,145,147,148,151,152,154,155行目`を改変。勝利した時に、テキストが表示されるようにし、ウィンドウを閉じるようにした。
```python
    if tatehantei() == 1:
        tmsg.showinfo("結果", "先行プレイヤーの勝ち！")
        root.destroy()
    elif tatehantei() == -1:
        tmsg.showinfo("結果", "後攻プレイヤーの勝ち！")
        root.destroy()

    if yokohantei() == 1:
        tmsg.showinfo("結果", "先行プレイヤーの勝ち！")
        root.destroy()
    elif yokohantei() == -1:
        tmsg.showinfo("結果", "後攻プレイヤーの勝ち！")
        root.destroy()

    if nanamehantei() == 1:
        tmsg.showinfo("結果", "先行プレイヤーの勝ち！")
        root.destroy()
    elif nanamehantei() == -1:
        tmsg.showinfo("結果", "後攻プレイヤーの勝ち！")
        root.destroy()
```

# ボタンの初期化
**ボタンを初期化**  
`167行目`を改変。色を設置。
```python
def init_text():
    global BUTTON
    for x in range(3):
        for y in range(3):
            BUTTON[x][y]["text"] = ""
            BUTTON[x][y]["foreground"] = "" 
```

# ボタン設置
**３ｘ３にボタンを設置**
```python
for x in range(3):
        for y in range(3):
            BUTTON[y][x].grid(column=y , row=x)
```
# 引用
[〇✕ゲーム（三目並べ）のソースコードを参照](https://www.frankdaigakusei.com/programming/marubatu-game/)

